/**
 * @file Task_Button.c
 * @author plus (chengmeng_2@outlook.com)
 * @brief ¼
 * @version 0.1
 * @date 2023-04-16
 *
 * @copyright Copyright (c) 2023
 *
 */
#include "main.h"
#include "multi_button.h"
#include "STC32G_UART.h"
/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
static struct Button button1;
/* Private function prototypes -----------------------------------------------*/
uint8_t read_button1_GPIO();
void BTN1_PRESS_DOWN_Handler(void *btn);
void BTN1_PRESS_UP_Handler(void *btn);
void Callback_SINGLE_CLICK_Handler(void *btn);
void Callback_DOUBLE_Click_Handler(void *btn);
/* Private functions ---------------------------------------------------------*/
void Task_Button_Init()
{
    KEY_init();
    button_init(&button1, read_button1_GPIO, 0);
    button_attach(&button1, PRESS_DOWN, BTN1_PRESS_DOWN_Handler);
    button_attach(&button1, PRESS_UP, BTN1_PRESS_UP_Handler);
    button_attach(&button1, SINGLE_CLICK, Callback_SINGLE_CLICK_Handler);
    button_attach(&button1, DOUBLE_CLICK, Callback_DOUBLE_Click_Handler);
    button_start(&button1);
}
void Task_Button_tick()
{
    uint32_t tick_curr = Tick_GetClock();
    {
        static uint32_t tick_last; // δʱ
        if (tick_curr > tick_last + 5)
        { //
            button_ticks();
        }
    }
}
uint8_t read_button1_GPIO()
{
    return KEY_GetState(KEY_ID_1);
}
void BTN1_PRESS_DOWN_Handler(void *btn)
{
    PrintString1("BTN1_PRESS_DOWN_Handler!\r\n"); // UART1һַ
}

void BTN1_PRESS_UP_Handler(void *btn)
{
    PrintString1("BTN1_PRESS_UP_Handler!\r\n"); // UART1һַ
}
void Callback_SINGLE_CLICK_Handler(void *btn)
{
    PrintString1("Callback_SINGLE_CLICK_Handler!\r\n"); // UART1һַ
}

void Callback_DOUBLE_Click_Handler(void *btn)
{
    PrintString1("Callback_DOUBLE_Click_Handler!\r\n"); // UART1һַ
}
