/**
 * @file bsp_led.h
 * @author plus (chengmeng_2@outlook.com)
 * @brief stc32G LED
 * @version 0.1
 * @date 2023-04-12
 *
 * @copyright Copyright (c) 2023
 *
 */

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __BSP_LED_H_
#define __BSP_LED_H_

/* Private includes ----------------------------------------------------------*/
#include "stdint.h"

/* Exported types ------------------------------------------------------------*/
typedef enum
{
    LED_RED_PIN = 0x01,
    LED_GREEN_PIN = 0x02,
    LED_YELLOW_PIN = 0x04
} LED_PORT;
/* Exported constants --------------------------------------------------------*/
/* Exported macro ------------------------------------------------------------*/
#ifndef bool
#define bool uint8_t
#endif
/* Exported functions prototypes ---------------------------------------------*/
/**
 * @brief ʼLED
 *
 */
void LED_Init(void);
void LED_DeInit(void);
/**
 * @brief LED
 *
 * @param value 0bit red;1bit green;2bit yellow  1: 0:
 */
void LED_setLED_all(uint8_t value);

/**
 * @brief LED
 *
 * @param port LED˿ @ref see LED_PORT
 * @param ture 
 * @param false 
 */
void LED_setLED(LED_PORT port, bool value);
#endif
