/**
 * @file bsp_key.c
 * @author plus (chengmeng_2@outlook.com)
 * @brief 
 * | Port      | name |
 * | --------- | ---- |
 * | KEY1_INIT | P32  |
 * | KEY2_RST  | P54  |
 * @version 0.1
 * @date 2023-04-16
 *
 * @copyright Copyright (c) 2023
 *
 */
#include "bsp_key.h"
#include "STC32G_GPIO_extend.h"
/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/
void KEY_init()
{                                     // 00׼˫ 01 10 11©
    MODE_IN_HIZ(GPIO_P3, GPIO_Pin_2); // key IOΪ
    MODE_IN_HIZ(GPIO_P5, GPIO_Pin_4);
    GPIO_PULL_UP_ENABLE(GPIO_P3, GPIO_Pin_2); // õIO
    GPIO_PULL_UP_ENABLE(GPIO_P5, GPIO_Pin_4);
    GPIO_DIGIT_IN_ENABLE(GPIO_P3, GPIO_Pin_2); // ʹ
    GPIO_DIGIT_IN_ENABLE(GPIO_P5, GPIO_Pin_4);
}

uint8_t KEY_GetValue(void)
{
    uint8_t value = 0;
    value |= KEY_GetState(KEY_ID_1) << 0;
    value |= KEY_GetState(KEY_ID_2) << 1;
    return value;
}
uint8_t KEY_GetState(KEY_ID_T id)
{
    switch (id)
    {
    case KEY_ID_1:
        return GPIO_READ_BIT(GPIO_P3, 2) != 0;
    case KEY_ID_2:
        return GPIO_READ_BIT(GPIO_P5, 4) != 0;
    default:
        return 0;
        break;
    }
}
