/**
 * @file bsp_KEY.h
 * @author plus (chengmeng_2@outlook.com)
 * @brief 
 * | Port      | name |
 * | --------- | ---- |
 * | KEY1_INIT | P32  |
 * | KEY2_RST  | P54  |
 * @version 0.1
 * @date 2023-04-16
 *
 * @copyright Copyright (c) 2023
 *
 */
/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __BSP_KEY_H_
#define __BSP_KEY_H_

/* Private includes ----------------------------------------------------------*/
#include "stdint.h"

/* Exported types ------------------------------------------------------------*/
typedef enum KEY_ID
{
    KEY_ID_1, /* KEY P3.2*/
    KEY_ID_2, /* KEY P5.4*/
} KEY_ID_T;
/* Exported constants --------------------------------------------------------*/
/* Exported macro ------------------------------------------------------------*/
/* Exported functions prototypes ---------------------------------------------*/
void KEY_init(void);
uint8_t KEY_GetValue(void);
uint8_t KEY_GetState(KEY_ID_T id);
#endif //__BSP_KEY_H_
