/**
 * @file STC32G_GPIO_EXTEND
 * COPYRIGHT (C) 2022,  chengmeng_2@outlook.com Co., Ltd.
 * All rights reserved.
 * @brief stc32G gpio driver externd
 * @details stc32G ٷĺ궨 
 *
 * @version ver1.0
 * @date 202269
 * @author cmm
 * @note
 */

#ifndef __STC32G_GPIO_EXT_H_
#define __STC32G_GPIO_EXT_H_

#include "stc32G_GPIO.h"

/*!< ƴGPIOĴ */
#define PxReg(Pn, PinName) P##Pn##PinName

/*!< Ĵĳ  */
#define REG_BIT_ADD(Port, Pin) Port &= (Pin)
#define REG_BIT_OR(Port, Pin) Port |= (Pin)

// M1  default 0xFF
// M0  default 0x00
#define PxM1_SET(Port, Pin) REG_BIT_OR(PxReg(Port, M1), Pin)
#define PxM1_ReSet(Port, Pin) REG_BIT_ADD(PxReg(Port, M1), ~(Pin))
#define PxM0_SET(Port, Pin) REG_BIT_OR(PxReg(Port, M0), Pin)
#define PxM0_RESET(Port, Pin) REG_BIT_ADD(PxReg(Port, M1), ~(Pin))

//׼˫
#define MODE_IO_PU(Port, Pin)                         \
    {                                                 \
        PxM1_RESET(Port, Pin), PxM0_RESET(Port, Pin); \
    }
#define GPIO_MODE_IO_PU(Port, Pin) MODE_IO_PU(Port, Pin)
//
#define MODE_IN_HIZ(Port, Pin)                      \
    {                                               \
        PxM1_SET(Port, Pin), PxM0_RESET(Port, Pin); \
    }
#define GPIO_MODE_IN_HIZ(Port, Pin) MODE_IN_HIZ(Port, Pin)
//©·
#define MODE_OUT_OD(Port, Pin)                    \
    {                                             \
        PxM1_SET(Port, Pin), PxM0_SET(Port, Pin); \
    }
#define GPIO_MODE_OUT_OD(Port, Pin) MODE_OUT_OD(Port, Pin)
//
#define MODE_OUT_PP(Port, Pin)                    \
    {                                             \
        PxM1_RESET(Port, Pin), PxM0_SET(Pn, Pin); \
    }
#define GPIO_MODE_OUT_PP(Port, Pin) MODE_OUT_PP(Port, Pin)

//========================================================================
//                         ˿ڲ4.1K
//========================================================================
//ʹ default 0x00
#define GPIO_PULL_UP_ENABLE(Port, Pin) REG_BIT_OR(PxReg(Port, PU), Pin)
//ֹ
#define GPIO_PULL_UP_DISABLE(Port, Pin) REG_BIT_ADD(PxReg(Port, PU), ~(Pin))
//========================================================================
//                           ˿ʩش
//========================================================================
//ʩشʹ default 0x00
#define GPIO_ST_ENABLE(Port, Pin) REG_BIT_OR(PxReg(Port, NCS), Pin)
//ʩشֹ
#define GPIO_ST_DISABLE(Port, Pin) REG_BIT_ADD(PxReg(Port, NCS), ~(Pin))

//========================================================================
//                          ˿ڵƽתٶ
//========================================================================
//ƽת٣Ӧ³ȽС
#define GPIO_SPEED_LOW(Port, Pin) REG_BIT_OR(PxReg(Port, SR), Pin)
//ƽת٣Ӧ³Ƚϴ
#define GPIO_SPEED_HIGH(Port, Pin) REG_BIT_ADD(PxReg(Port, SR), ~(Pin))

//========================================================================
//                          ˿
//========================================================================
//һ default 0xFF
#define GPIO_DRIVE_MEDIUM(Port, Pin) REG_BIT_OR(PxReg(Port, DR), Pin)
//ǿ
#define GPIO_DRIVE_HIGH(Port, Pin) REG_BIT_ADD(PxReg(Port, DR), ~(Pin))

//========================================================================
//                          ˿źʹ
//========================================================================
//ʹź  default 0xFF
#define GPIO_DIGIT_IN_ENABLE(Port, Pin) REG_BIT_OR(PxReg(Port, IE), Pin)
//ֹź
#define GPIO_DIGIT_IN_DISABLE(Port, Pin) REG_BIT_ADD(PxReg(Port, IE), ~(Pin))

//========================================================================
//                          ˿źʹ
//========================================================================
//д  
#define GPIO_WRITE_BIT(Port, Pin, flag) (PxReg(Port, Pin) = flag)
//ȡ
#define GPIO_READ_BIT(Port, Pin) PxReg(Port, Pin)

#endif
